-- By D4KiR

MIPO = MIPO or {}
MIPOPC = MIPOPC or {}

MIPO.name = "Missing Power"
MIPO.colorname = "|c008888ff"
MIPO.author = "D4KiR"
MIPO.colorauthor = "|c0000ffff"

SetCVar("ScriptErrors", 1)
MIPO.DEBUG = false

MIPOPC["DEBUG"] = false

function MIPOGetConfig(str, val)
	local setting = val
	if MIPOPC ~= nil then
		if MIPOPC[str] == nil then
			MIPOPC[str] = val
		end
		setting = MIPOPC[str]
	end
	return setting
end

if not IsRetail() then
	local roles = {}

	UnitGroupRolesAssigned = UnitGroupRolesAssigned or function(Unit)
		Unit = Unit or "NONE"
		Unit = string.upper(Unit)
		local role = roles[Unit] or "NONE"
		return role
	end

	function SetGroupRole(author, role)
		local found = false
		role = string.upper(role)
		if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			for i, v in pairs(GetHomePartyInfo()) do
				if author == v then
					roles["PARTY" .. i] = string.upper(role)
					found = true
				end
			end
			if UnitName("PLAYER", true) == author then
				roles["PLAYER"] = role
				found = true
			end
			if not found then
				print("Author not found! " .. author)
			end
		end
	end

	local function dFilter(self, event, msg, author, ...)
		local startpos = string.find(author, "-")
		if startpos then
			author = string.sub(author, 0, startpos - 1)
		end
		msg = string.lower(msg)
		if msg:find("!tank") then
			SetGroupRole(author, "TANK")
		elseif msg:find("!dd") then
			SetGroupRole(author, "DAMAGER")
		elseif msg:find("!healer") then
			SetGroupRole(author, "HEALER")
		end
	end
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", dFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", dFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", dFilter)
end
